SystemOrganization addCategory: #'tODE-Amber'!

WAComponent subclass: #TOAmberAbstractComponent
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberAbstractComponent methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:25'!
object
	^ object! !

!TOAmberAbstractComponent methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:25'!
object: anObject
	object := anObject! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
renderContentOn: json
	self subclassResponsibility! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
renderJsonOn: aRenderer
	self renderWithContext: aRenderer context! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
rendererClass
	^ WAJsonCanvas! !

TOAmberAbstractComponent subclass: #TOAmberFrameComponent
	instanceVariableNames: 'selectedTab expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberFrameComponent class methodsFor: 'class initialization' stamp: 'dkh 10/10/2011 13:33'!
initialize
	"self initialize"

	(WAJsonAdmin register: self asApplicationAt: 'tools/amber/frame') exceptionHandler: TOAmberErrorHandler! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/15/2011 10:25'!
configurationInfo
    | configurationInfo wc |
    MCWorkingCopy registry
        do: [ :mgr | 
            (mgr packageInfo includesClass: self objectClass)
                ifTrue: [ wc := mgr ] ].
    wc ifNil: [ ^ nil ].
    MBConfigurationRoot current configurations
        do: [ :config | 
            config packages
                do: [ :pkg | 
                    pkg basePackageName = wc packageName
                        ifTrue: [ 
                            configurationInfo := config.
                            ^ config ] ] ].
    ^ configurationInfo! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:39'!
expression

	^expression! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:39'!
expression: aString

	expression := aString! !

!TOAmberFrameComponent methodsFor: 'hooks' stamp: 'dkh 10/9/2011 11:44'!
initialRequest: aRequest
	super initialRequest: aRequest.
	aRequest fields at: 'selectedTab' ifPresent: [ :tab | self selectedTab: tab ].
! !

!TOAmberFrameComponent methodsFor: 'mock' stamp: 'dkh 10/3/2011 23:06'!
jsonRendererForTab: tab
	tab = 'view'
		ifTrue: [ 
			^ (TOAmberInspectorRenderer new)
				object: self object;
				yourself ].
	^TOAmberNullRenderer new! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:45'!
notifier
	^ TOPharoCompilationRequestor new requestor: self! !

!TOAmberFrameComponent methodsFor: 'mock' stamp: 'dkh 10/15/2011 10:15'!
object
	object ifNil: [ ^ object := TORoot current currentSession homeObject ].
	^ object! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/15/2011 10:33'!
objectClass
    ^ self object class theNonMetaClass! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/15/2011 10:26'!
packageInfo
    | wc |
    MCWorkingCopy registry
        do: [ :mgr | 
            (mgr packageInfo includesClass: self objectClass)
                ifTrue: [ wc := mgr ] ].
    wc ifNil: [ ^ nil ].
    MBConfigurationRoot current configurations
        do: [ :config | 
            config packages
                do: [ :pkg | 
                    pkg basePackageName = wc packageName
                        ifTrue: [ ^ pkg ] ] ].
    ^ MBPackageInfo named: wc packageName! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:21'!
renderClassOn: json
	json render: self object class theNonMetaClass name asString! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/15/2011 10:08'!
renderContentOn: json
    self expression
        ifNotNil: [ :exp | 
            | result |
            self expression: nil.
            result := TORoot current currentSession currentSystem
                evaluate: exp
                in: nil
                to: self object
                notifying: self notifier
                ifFail: [ self error: 'evaluation failed' ].
            json object: [ json key: 'url' value: [ json callback: [ self object: result ] ] ].
            ^ self ].
    json
        object: [ 
            json key: 'class' value: [ self renderClassOn: json ].
            json key: 'header' value: [ self renderHeaderOn: json ].
            json key: 'todeTitle' value: [ self renderTodeTitleOn: json ].
            json key: 'tabLabels' value: [ self renderTabsOn: json ].
            json
                key: 'url'
                value: [ 
                    json
                        callback: [ 
                            self requestContext request url queryFields at: 'expression' ifPresent: [ :exp | self expression: exp ].
                            self object: object ] ].
            self renderSelectedTabOn: json ]! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/16/2011 19:28'!
renderHeaderOn: json
    json
        object: [ 
            json
                key: 'configuration'
                value: [ 
                    | config |
                    self
                        renderHeaderOn: json
                        with:
                            ((config := self configurationInfo)
                                ifNil: [ 
                                    (TOAmberCreateConfigurationRenderer new)
                                        object: config;
                                        yourself ]
                                ifNotNil: [ 
                                    (TOAmberConfigurationRenderer new)
                                        object: config;
                                        yourself ]) ].
            json key: 'package' value: self packageInfo printString.
            json key: 'class' value: self objectClass name asString ]! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/16/2011 19:16'!
renderHeaderOn: json with: renderer
    json
        object: [ 
            renderer object
                ifNil: [ json key: 'title' value: 'No configuration' ]
                ifNotNil: [ json key: 'title' value: renderer object printString ].
            json key: 'state' value: [ renderer renderContentOn: json forFrame: self ].
            json key: 'renderBlockSource' value: renderer renderBlockSource ]! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 23:15'!
renderSelectedTabOn: json
	| tab renderer |
	tab := self selectedTab ifNil: [ self tabLabels first ].
	renderer := self jsonRendererForTab: tab.
	json key: 'state' value: [ renderer renderContentOn: json forFrame: self ].
	json key: 'renderBlockSource' value: renderer renderBlockSource! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:45'!
renderTabsOn: json
	json array: [ self tabLabels do: [ :label | json value: label ] ]! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:21'!
renderTodeTitleOn: json
	json render: self object tODETitle! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:38'!
selectedTab

	^selectedTab! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:39'!
selectedTab: aString

	selectedTab := aString! !

!TOAmberFrameComponent methodsFor: 'mock' stamp: 'dkh 10/3/2011 23:23'!
tabLabels
	^ #('view' 'help')! !

WAComponent subclass: #TOAmberCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberCounter class methodsFor: 'class initialization' stamp: 'dkh 9/26/2011 21:15'!
addLibraries: aToMainApplication

	aToMainApplication
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		addLibrary: TOJQueryLibrary;
		addLibrary: TOStyleSheet! !

!TOAmberCounter class methodsFor: 'accessing' stamp: 'dkh 9/26/2011 21:17'!
description
	^ 'Amber & Seaside-JSON example counter'! !

!TOAmberCounter class methodsFor: 'class initialization' stamp: 'dkh 9/26/2011 21:22'!
initialize
	"self initialize"

	| application |
	(application := WAAdmin
		register: self
		asApplicationAt: 'tools/amber-counter'
		user: 'admin'
		password: 'tool')
		preferenceAt: #sessionClass put: TOSeasideSession;
		exceptionHandler: TOSeasideErrorHandler.
	self addLibraries: application	"exception handler for TOMain is always TOSeasideErrorHandler"! !

!TOAmberCounter methodsFor: 'rendering' stamp: 'dkh 10/5/2011 17:33'!
renderContentOn: html
	html script url: '/Kaliningrad/js/amber.js'.
	html script with: 'loadAmber({
	   files: [''KaliningradCore.js'', ''tODEAmberClient.js'']
	 })'.
	html strong: 'Amber Counter:'.
	html break.
	html script with: 'smalltalk.TOASeasideCounter._open()'.
! !

!TOAmberCounter methodsFor: 'rendering' stamp: 'dkh 9/26/2011 21:47'!
updateRoot: aHtmlRoot

	super updateRoot: aHtmlRoot.
	aHtmlRoot title: 'Amber Counter'.
! !

WAComponent subclass: #TOAmberMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberMain class methodsFor: 'class initialization' stamp: 'dkh 9/25/2011 11:33'!
addLibraries: aToMainApplication

	aToMainApplication
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		addLibrary: TOJQueryLibrary;
		addLibrary: TOStyleSheet! !

!TOAmberMain class methodsFor: 'accessing' stamp: 'dkh 9/26/2011 21:08'!
description
	^ 'tODE Amber Main'! !

!TOAmberMain class methodsFor: 'class initialization' stamp: 'dkh 10/5/2011 17:32'!
initialize
	"self initialize"

	| application |
	(application := WAAdmin
		register: self
		asApplicationAt: 'tools/amber-tODE'
		user: 'admin'
		password: 'tool')
		preferenceAt: #sessionClass put: TOSeasideSession;
		exceptionHandler: TOSeasideErrorHandler.
	self addLibraries: application.
	KOAmberBrowser addAmberFile: 'tODEAmberClient.js'	"until tODE can be used to edit Amber code"! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/5/2011 17:52'!
renderContentOn: html
	html document addLoadScript: (html jQuery ajaxSetup onError: html javascript refresh).
	html script with: 'smalltalk.TOAMain._open()'! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/15/2011 16:06'!
style
	^'
html {height:100%; overflow:hidden}
	body {
		overflow:auto;
		height:100%;
		margin:0;
		padding:0;
		font-size:11px;
		font-family:Verdana}
 	h1 {color:#ff7200;background:#ddd;margin:0;padding:4px;padding-bottom:0px}

		.ui-layout-content {
                        height: 100%;
                        width: 100%;
			overflow:		auto; /* add scrolling to content-divs (panel-wrappers) */

			border-top:		0 !!important; /* tab-buttons above this DIV already has a border-bottom */
		}


		.ui-tabs-nav li {

			white-space:	nowrap;

		}

		.ui-tabs-nav li a {

			font-size:		1em !!important;

			padding:		4px 1.5ex 3px !!important;

		}

		.ui-tabs-panel {

			font-size:		1em !!important;

			padding:		0 1em !!important;

		}


	.ui-layout-resizer {   
		background: #DDD; 
	}

 
	.ui-layout-toggler {  
		background: #AAA; 
	} 
	.ui-layout-toggler .content {
	   font-size: 12px; /* IMPORTANT: default = 1px */
	   font-weight: bold;
	   text-align: center}
	.ui-layout-toggler-north .content {   
		 font-size: 7px;
	} 

#north .ltab, #north .rtab, #north .mtab {
    height: 22px;
    float: left;
}

#north .ltab, #north .rtab {
    width: 8px;
}

#north .rtab {
    margin-right: 1px;
}

#north .mtab {
    line-height: 20px;
}

'
! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/15/2011 13:57'!
updateRoot: aHtmlRoot

	aHtmlRoot title: 'Amber tODE'.
	aHtmlRoot addScript: '$(document).ready(function () {
	$(''body'').layout({ 
north : {
   size : ''auto''
,  resizable : false
,  togglerLength_open : 20
,  togglerLength_closed : 20
,  togglerContent_closed : ''v''
,  togglerContent_open : ''^''
}
, south : {
   size : 120
}
});
})'.
	aHtmlRoot script url: '/Kaliningrad/js/amber.js'.
	aHtmlRoot addScript: 'loadAmber({
	   files: [''KaliningradCore.js'', ''tODEAmberClient.js'']
	 })'.
	super updateRoot: aHtmlRoot! !

WAWalkbackErrorHandler subclass: #TOAmberErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberErrorHandler class methodsFor: 'exception handling' stamp: 'dkh 10/9/2011 13:52'!
exceptionSelector
	^ super exceptionSelector, Halt! !

!TOAmberErrorHandler methodsFor: 'actions' stamp: 'dkh 10/9/2011 13:52'!
handleException: anException
	(Halt handles: anException)
		ifTrue: [ ^ self handleHalt: anException ].

	^ super handleException: anException! !

!TOAmberErrorHandler methodsFor: 'actions' stamp: 'dkh 10/9/2011 13:52'!
handleHalt: anError

	^ self handleDefault: anError! !

!TOAmberErrorHandler methodsFor: 'actions' stamp: 'dkh 10/10/2011 14:08'!
open: anException
	| renderer |
	[renderer := (TOAmberFrameComponent new)
		object: anException;
		yourself.
	self session presenter call: renderer onAnswer: [  ]] on: Error do: [:ex | super open: ex ].! !

WAJsonComponent subclass: #TOJsonCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOJsonCounter class methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:06'!
initialize
	"self initialize"
	
	self register! !

!TOJsonCounter class methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:05'!
register
	(WAJsonAdmin register: self asApplicationAt: 'tools/json-counter')
		exceptionHandler: WAHtmlHaltAndErrorHandler.! !

!TOJsonCounter methodsFor: 'actions' stamp: 'dkh 9/24/2011 22:04'!
decrease
	count := count - 1! !

!TOJsonCounter methodsFor: 'actions' stamp: 'dkh 9/25/2011 10:22'!
increase
	count := count + 1! !

!TOJsonCounter methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:04'!
initialize
	super initialize.
	count := 0! !

!TOJsonCounter methodsFor: 'as yet unclassified' stamp: 'dkh 9/27/2011 21:10'!
renderActionsOn: json
	json
		key: 'increase' value: [ json callback: [ self increase ] ];
		key: 'decrease' value: [ json callback: [ self decrease ] ]! !

!TOJsonCounter methodsFor: 'as yet unclassified' stamp: 'dkh 9/27/2011 21:09'!
renderStateOn: json
	json key: 'count' value: count! !

Object subclass: #TOAmberAbstractRenderer
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:51'!
object
	^ object! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:51'!
object: anObject
	object := anObject! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 18:01'!
renderBlockMethod
    ^[:frame :obj :html :main | ]
! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 18:01'!
renderBlockSource

	^self renderBlockMethod asString! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 19:00'!
renderContentOn: json forFrame: aFrameComponent
    ^ json value: 'null'! !

TOAmberAbstractRenderer subclass: #TOAmberConfigurationRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 19:07'!
renderBlockMethod
    ^ [ :frame :obj :html :main | html with: 'Hello world' ]! !

!TOAmberConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 19:21'!
renderContentOn: json forFrame: aFrameComponent
    ^ json value: 'null'! !

!TOAmberConfigurationRenderer methodsFor: 'accessing' stamp: 'dkh 10/16/2011 19:31'!
repositories
	^ (MCRepositoryGroup default repositories reject: [ :repo | repo = MCCacheRepository default ])
		sorted: [ :a :b | a description <= b description ]! !

TOAmberConfigurationRenderer subclass: #TOAmberCreateConfigurationRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberCreateConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 21:02'!
renderBlockMethod
    ^ [ :frame :obj :html :main | 
    | input |
    html button with: 'Create configuration'.
    input := html inputWithExampleText: 'Configuration name'.
    html select with: [ obj state repositories do: [ :repository | html option with: repository ] ] ]! !

!TOAmberCreateConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 19:47'!
renderContentOn: json forFrame: aFrameComponent
    ^ json
        object: [ json key: 'repositories' value: [ json array: [ self repositories do: [ :repo | json value: repo description ] ] ] ]! !

TOAmberAbstractRenderer subclass: #TOAmberExceptionRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

TOAmberAbstractRenderer subclass: #TOAmberInspectorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberInspectorRenderer methodsFor: 'rendering' stamp: 'dkh 10/15/2011 09:21'!
renderBlockMethod
    "[:frame :object :html :main | ...]"

    ^ [ :frame :obj :html :main | 
    html table
        with: [ 
            obj state members
                do: [ :member | 
                    html tr
                        with: [ 
                            | td |
                            td := html td.
                            td style: 'padding: .3px 4px;'.
                            td
                                with: [ 
                                    | key url |
                                    key := member key.
                                    (url := key at: 2) isNil
                                        ifTrue: [ html with: (key at: 1) ]
                                        ifFalse: [ 
                                            (html a)
                                                href: '#';
                                                onClick: [ 
                                                            frame session push: url.
                                                            main renderCenter ];
                                                with: (key at: 1) ] ].
                            td := html td.
                            td style: 'padding: .3px 4px;'.
                            td
                                with: [ 
                                    | value url |
                                    value := member value.
                                    (url := value at: 2) isNil
                                        ifTrue: [ html with: (value at: 1) ]
                                        ifFalse: [ 
                                            (html a)
                                                href: '#';
                                                onClick: [ 
                                                            frame session push: url.
                                                            main renderCenter ];
                                                with: (value at: 1) ] ] ] ] ] ]! !

!TOAmberInspectorRenderer methodsFor: 'rendering' stamp: 'dkh 10/15/2011 10:05'!
renderContentOn: json forFrame: aFrameComponent
    | members |
    members := TORoot current currentSession currentSystem
        inspectorField: #tODEBasicInspectorFields
        from: self object class
        to: nil
        for: self object.
    json
        object: [ 
            json
                key: 'members'
                value: [ 
                    json
                        array: [ 
                            members
                                do: [ :fieldSpec | 
                                    json
                                        value: [ 
                                            json
                                                object: [ 
                                                    json
                                                        key: 'key'
                                                        value: [ 
                                                            json
                                                                array: [ 
                                                                    json value: fieldSpec keyLabel.
                                                                    fieldSpec hasKey
                                                                        ifTrue: [ json value: [ json callback: [ aFrameComponent object: fieldSpec key ] ] ]
                                                                        ifFalse: [ json value: nil ] ] ].
                                                    json
                                                        key: 'value'
                                                        value: [ 
                                                            json
                                                                array: [ 
                                                                    json value: fieldSpec valueLabel.
                                                                    fieldSpec hasValue
                                                                        ifTrue: [ json value: [ json callback: [ aFrameComponent object: fieldSpec value ] ] ]
                                                                        ifFalse: [ json value: nil ] ] ] ] ] ] ] ] ]! !

TOAmberAbstractRenderer subclass: #TOAmberNullRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!
TOAmberFrameComponent initialize!
TOAmberCounter initialize!
TOAmberMain initialize!
TOJsonCounter initialize!
